; How  TiOs runs an asm program an AMS 2.05 :
; Basic / Asm 
;	Em_twinSymFromExtMem
;	DerefSym ?
;	NextexpressionIndex ?
;	all_tail ?
;	VarRecall ?
;	DerefSym ?
;	HtoESI ?
;	Test ASM signature ($F3)
; Asm	
;	Handle of program
;	If GetLock(Hd) => ER_throw($A244)
;	If Hd->Ptr-$6880 < $FFFF (AMS 2.0x spec)
;		HeapMoveHigh(Hd)
;		HtoESI(Hd)
;	ER_cath			(AMS 2.0x spec)
;		HeapLock(Hd)
;		Si Size(Hd) > $6000 (AMS 2.0x spec)
;			Er_throw($A0A1)
;		EX_patch(Start, end)
;		Trap B ($5D86,d3 = F) (AMS 2.0x spec)
;		Call programs
;		Something in $6888 (About Estack)
;		HeapUnLock(Hd)
;		If DerefSym(Sym).flags.10
;			bset #0,$64F1 ???
;		ER_success
;	Else (FA)
;		HeapUnLock(Hd)
;		If DerefSym(Sym).flags.10
;			bset #0,$64F1 ???
;		ER_throwVar(d3)
;	
newER_throw:
	pea	(a0)			; Push a0
	lea	FirstRun(Pc),a0		; Test si on est au dernier mode (Securite)
	cmpi.b	#-1,(a0)
	beq.s	crash_handler		; Oui => Crash Handler
	
	move.l	6(sp),a0		; L'addesse du crash
	cmp.w	#$A000+161,(a0)		; Test if it is 'Too long Exec Program'
	beq.s	\return
	cmp.w	#$A244,(a0)		; Test if 'Illegal Program Reference'
	bne.s	\no
		cmpi.b	#$F3,(a3)	; Check if is an ASM program (Youla, a3...)
		bne.s	\no
\return			addq.l	#2,6(sp)	; Skip the illegal
			move.l	(a7)+,a0
			rte		; On continue comme si rien n'avait eu lieu :)
\no	move.l	(a7)+,a0		; Restaure a0
OldER_throw
	jmp	($0).l			; Saut a l'ancienne ER_throw
	
new1111:				; We don't to save the register since if it is else a crash, else a ROM_CALL
	move.l	2(sp),a0		; Address of the 'crash'
	move.w	(a0),d0			; On recupere l'instruction
	cmp.w	#$F800,d0		; C'est > $F8xx ?
	blt.s	\no			; Non, utilise l'ancien appel
		andi.l	#$7ff,d0	; RomCall numero
		move.l	($C8).w,a1	; L'adresse de la base
		cmp.l	-4(a1),d0	; Le nombre d'entree dans la base
		bge.s	\no		; Non, c'est superieur
			lsl.w	#2,d0		; * 4
			move.l	0(a1,d0.w),a1	; + ($C8)
			move.l	a1,2(sp) 	; Sauve la ROM_CALL
			addq.l	#2,a0		; Calcule de l'adresse de retour
			btst.b	#5,(sp)		; Test mode superviseur ou User
			bne.s	\super
				move	usp,a1		; On va deposer sur la pile user
				move.l	a0,-(a1)	; l'adresse de retour
				move	a1,usp		; Sauve la pile
				rte			; Fin d'Exception
\super:			move.w	(sp)+,SR	; On Recharge SR
			move.l	a0,(sp)		; On sauve l'adresse de retour
			jmp	(a1)		; On appelle la fonction
\no:
;	move.w	FirstRun(Pc),d0		; Test si kernel mode ?
;	bne.s	crash_handler		; Oui => Crash handler
;Old1111:	jmp	($0).l		; Saut a l'ancien emulateur erreur

crash_handler:					; Crash handlers
	move.w  #$2700,SR			; Stop interrupts (Is it necessary ?)
	move.w	FirstRun(pc),d0			; Test if crash under kernel mode ?
	beq.s	nostub_error			; No => Mode nostub
	cmpi.w	#$FF00,d0			; Crash under Kernel Anti-Crash ?
	beq.s	nostub_error			; Yes => Mode nostub
	lea	OrgStack(pc),a1
	lea	errortext(pc),a0
	move.l	a0,(a1)				; Get Error string and save it
	addq.l	#6,sp				; Pop SR / Return addr
	suba.l	a5,a5				; A5 -> Current prog.
	move.w	#$0500,SR			; User Mode / auto-ints fordidden
	bra.w	_quit				; But On-Auto-int6 and Privile violation auto int are allows ! (Since it can crashs after !)
		
newint6:
	btst.b	#1,$60001A		; Test if ON key if effectively pressed
	bne.s	oldint6			; ON key is not pressed
	move.l	d0,-(sp)		; Save d0
					; Test if ESC is pressed
int6msk	move.w	#%0111111,$600018	; Write mask (int1 & 5 can't be called ;)
	moveq	#$58,d0			; TiOs uses $58
\loop:		dbra d0,\loop		; Autant faire une bonne lecture :)
int6key	btst	#0,$60001B		; Read Key Matrix 
	beq.s	crash_handler		; Yes => Crash handler
Statut	btst	#2,($6760).w		; SHIFT has been pressed ?
	beq.s	NoShell
		move.l ($4C).w,d0	; Test si on est deja memorise l'appel
		bne.s	NoShell
			move.l	($80).w,($4004C); Save old Trap
Trap0Adr		move.l	#0,($40080)	; New Trap #0
			move.l (sp)+,d0		; Restore d0
			rte			; Don't call original int6
NoShell	move.l	(sp)+,d0		; Restore d0
oldint6	jmp	($0).l

nostub_error:
	bsr	kernel_install_int	; ReInstall ints.		// CAN NOT CRASH
	bsr	reinstall_tios_vars	; Ports / AutoInts / Screen	// CAN NOT CRASH
	ROM_THROW PortRestore		; PortRestore (Works under Supervisor mode) // CAN NOT CRASH

;\w	bra.s	\w
;	move.l	($C8).w,a0
;	cmp.l	#1108,-4(a0)		; AMS 2.0x I will prefer an iline patch...
;	bcs.s	\ams1
;;		pea	TiHomeStr(Pc)	; Get the first ACB handle
;		ROM_THROW 1108 		; EV_getAppID
;\back			move.w	d0,(sp)		; Push ACB Handle
;			move.w	d0,d3		; Save current ACB Handle
;			ROM_THROW HeapDeref	; Get ACB struct
;			move.w	6(a0),d0	; Get Previous ACB Handle
;			bne.s	\back
;		lea	-120(sp),sp	; Get an EVENT struct and an ERROR frame
;		move.l	sp,a2		; Get Event ptr
;		lea	60(sp),a3	; Get Error frame ptr
;\uninstall		pea	(a2)		; Push Event ptr
;			move.w	d3,-(a7)	; Push ACB Handle
;			ROM_THROW HeapDeref
;			move.w	4(a0),d3	; Get Next ACB Handle
;			pea	(a3)		; Push ERROR FRAME
;			ROM_THROW ER_catch	; AMS can call ER_Throw
;			addq.l	#4,sp
;			tst.w	d0		; A ER_throw has been called ?
;			bne.s	\error
;				move.w	#$706,(a2)		; CM_DEACTIVATE
;				ROM_THROW EV_sendEvent		; Send the event to the application
;				addq.w	#($707-$706),(a2)	; CM_ENDTASK or CM_QUIT
;				ROM_THROW EV_sendEvent
;				addq.w	#($70D-$707),(a2)	; CM_UNINSTALL
;				ROM_THROW EV_sendEvent
;				ROM_THROW ER_success		; Pop the error frame
;\error			addq.l	#6,sp
;			tst.w	d3
;			bne.s	\uninstall
;		lea	(124)(sp),sp	; Pop ER_frame, Event and TiHomeStr Ptr
;\ams1	
	move.w	#$0000,SR		; SR = $0000
FirstWin	clr.l	($6000).w		; Reset Windows List
ErrorFrameAdr	clr.l	($5CF8).w		; Reset ERROR FRAME
StackPtr	lea	($4200).w,a7		; ReLoad stack ptr
;CentralPatch	move.l	#$0F96A5F0,($5CE4).w	; Do not restart all the applications
	ROM_THROW EV_centralDispatcher		; Redo the main loop

NewTrap0
	move.l	($4C).w,($40080)	; Restaure original Trap #0
	trap	#0			; Call the original trap #0
	move.w	#$0000,SR		; User Mode
	movem.l	d0-d7/a0-a6,-(a7)	; Push all registers
	pea	($0F00).w		; Push SCREEN size
	ROM_THROW HeapAllocPtr		; Allocate a block to save the screen
	move.l	a0,(a7)			; Save a0 and test if a0 == NULL
	beq.s	\end2
		lea	(LCD_MEM).w,a1	; Copy the LCD_MEM into the buffer
		move.w	#$0F00/4-1,d0	; Buffer size / 4 (Longword copy)
\loop			move.l	(a1)+,(a0)+
			dbf	d0,\loop
		lea	doors_str(Pc),a0	
		bsr	find_lib		; Find File 'doors'
		move.l	a0,d0
		beq.s	\end
			HW2TSR_PATCH a0,d0	; Patch the file
			jsr	(a0)		; Execute
\end
		move.l	(a7),a0
		lea	(LCD_MEM).w,a1	; Restore the LCD_MEM
		move.w	#$0F00/4-1,d0	; Buffer size / 4 (Longword copy)
\loop2			move.l	(a0)+,(a1)+
			dbf	d0,\loop2
		ROM_THROW HeapFreePtr
\end2	addq.l	#4,a7
	ROM_THROW OSClearBreak
	movem.l	(a7)+,d0-d7/a0-a6	; restore all registers
	trap	#12			; Supervisor mode
	clr.l	($4004C)		; Efface la copie (On peut reutiliser le SHIFT+ON)
	rte

doors_str	dc.b	"doors",0
;TiHomeStr	dc.b	"TIHOME",0
	EVEN

;004A to 005F	2 + 4*5
;00CC to 00FF	13 x 4  

OldAutoInt1	dc.l	0	; $E0
OldAutoInt2	dc.l	0
OldAutoInt3	dc.l	0
OldAutoInt4	dc.l	0
OldAutoInt5	dc.l	0
OldAutoInt6	dc.l	0
OldAutoInt7	dc.l	0
