	include "RomCalls.h"

	xdef	_ti89
	xdef	_ti92plus
	xdef	_nostub

_main:
	movem.l d0-d7/a0-a6,-(a7)

	tst.w	($30).w		;regarde si un kernel est install
	bne.s	kernel
		pea	already(pc)
		bra.s	exit
kernel	cmp.w	#'PO',($32).w
	beq.s	uninstall
		pea	nopreos(Pc)
		bra.s	exit
uninstall

	move.l	($C8).w,d0
	andi.l	#$600000,d0
	add.l	#$012088,d0
	move.l	d0,a0
	lea	$40000,a1

	moveq	#63,d0
\loop		move.l	(a0)+,(a1)+
		dbf	d0,\loop

	move.w	($48).w,-(a7)
	ROM_CALL HeapFree		;libre la mmoire
	addq.l	#2,a7

	pea	success(pc)
exit:	ROM_CALL ST_showHelp
	addq.l	#4,a7

	movem.l (a7)+,d0-d7/a0-a6
	rts

success dc.b "PreOs uninstalled !",0
already dc.b "There is no Kernel !",0
nopreos	dc.b "Kernel <> PreOs !",0

	end
	